@import '../../styles/common';

// translate-offset equals handle-width - padding
$resource-list-item-variables: (
  padding: rem(12px),
  control-indent: -1 * rem(12px),
  min-height: rem(44px),
  handle-width: rem(48px),
  disclosure-width: rem(48px),
  translate-offset: rem(48px) - rem(12px) + spacing(extra-tight),
  clickable-stacking-order: 1,
  content-stacking-order: 2,
  actions-height: rem(56px),
  breakpoint-small: 458px,
);

@function resource-list-item($variable) {
  @return map-get($resource-list-item-variables, $variable);
}

@mixin action-hide {
  clip: rect(1px, 1px, 1px, 1px);
  overflow: hidden;
  height: 1px;
}

@mixin action-unhide {
  clip: auto;
  overflow: visible;
  height: 100%;
}

.CheckboxWrapper {
  display: flex;
}

.ResourceItem {
  position: relative;
  outline: none;
  cursor: pointer;

  &:not(.persistActions) {
    // stylelint-disable-next-line selector-max-combinators
    .Actions {
      right: spacing();
    }
  }

  &:hover {
    --p-surface-hovered: linear-gradient(
      rgba(223, 227, 232, 0.3),
      rgba(223, 227, 232, 0.3)
    );
    background: var(--p-surface-hovered);
    &:not(.persistActions) {
      // stylelint-disable-next-line selector-max-specificity
      .Actions {
        @include action-unhide;

        // stylelint-disable-next-line max-nesting-depth
        @include page-content-when-partially-condensed {
          display: none;
        }
      }
    }
  }

  &:active {
    background-color: var(--p-surface-pressed);
  }
}

.ItemWrapper {
  overflow: hidden;
  max-width: 100%;
}

// stylelint-disable-next-line selector-max-class
.focusedInner,
.focusedInner.focused,
.focusedInner.focused.selected {
  box-shadow: none;
}

.Link,
.Button {
  position: absolute;
  z-index: resource-list-item(clickable-stacking-order);
  top: 0;
  left: 0;
  height: 100%;
  width: 100%;
  opacity: 0;
}

.Button {
  padding: 0;
  border: none;
}

// Item inner container
.Container {
  position: relative;
  z-index: resource-list-item(content-stacking-order);
  padding: resource-list-item(padding) spacing();
  min-height: resource-list-item(min-height);
  display: flex;
  align-items: flex-start;

  @include breakpoint-after(resource-list-item(breakpoint-small)) {
    padding: resource-list-item(padding) spacing(loose);
  }
}

.alignmentLeading {
  align-items: flex-start;
}

.alignmentTrailing {
  align-items: flex-end;
}

.alignmentCenter {
  align-items: center;
}

.alignmentFill {
  align-items: stretch;
}

.alignmentBaseline {
  align-items: baseline;
}

.Owned {
  display: flex;
}

.OwnedNoMedia {
  padding-top: spacing(extra-tight);
}

// Item handle
.Handle {
  width: resource-list-item(handle-width);
  min-height: resource-list-item(min-height);
  justify-content: center;
  align-items: center;
  margin: (-1 * resource-list-item(padding)) spacing(extra-tight)
    (-1 * resource-list-item(padding)) resource-list-item(control-indent);
  display: flex;

  @include breakpoint-before(resource-list-item(breakpoint-small), false) {
    visibility: hidden;

    .selectMode & {
      visibility: visible;
    }
  }
}

.selectable {
  width: calc(100% + #{resource-list-item(translate-offset)});
  transform: translateX(-1 * resource-list-item(translate-offset));
  transition: transform easing() duration();
  margin-right: -1 * resource-list-item(translate-offset);

  &.selectMode {
    transform: translateX(0);
  }

  @include breakpoint-after(resource-list-item(breakpoint-small)) {
    width: 100%;
    transform: translateX(0);
    margin-right: 0;
  }
}

.Media {
  flex: 0 0 auto;
  margin-right: spacing(loose);
  color: inherit;
  text-decoration: none;
}

// Item content
.Content {
  @include layout-flex-fix;
  flex: 1 1 auto;
}

// Item actions
.Actions {
  position: absolute;
  top: 0;
  display: flex;
  pointer-events: initial;
  height: 100%;
  max-height: resource-list-item(actions-height);

  @include action-hide;

  .focused & {
    @include action-unhide;
  }

  @include page-content-when-partially-condensed {
    display: none;
  }
}

.persistActions {
  .Actions {
    position: relative;
    display: flex;
    flex: 0 0 auto;
    flex-basis: auto;
    align-items: center;
    margin-top: 0;
    margin-left: spacing();
    pointer-events: initial;
    height: 100%;

    @include page-content-when-partially-condensed {
      display: none;
    }
  }

  &:hover {
    background: none;
  }

  &:active {
    background: none;
  }
}

.Disclosure {
  position: relative;
  top: -1 * resource-list-item(padding);
  right: -1 * spacing();
  display: none;
  width: resource-list-item(disclosure-width);
  min-height: resource-list-item(min-height);
  pointer-events: initial;

  .selectMode & {
    display: none;
  }

  @include page-content-when-partially-condensed {
    display: flex;
    flex: 0 0 resource-list-item(disclosure-width);
    justify-content: center;
    align-items: center;
  }
}

.selected {
  --p-surface-RI-selected: linear-gradient(#393a4d, #393a4d);
  background: var(--p-surface-RI-selected);

  .Content {
    color: #ffffff;
  }

  &:hover {
    background: var(--p-surface-RI-selected) !important;
  }

  /* since we don't have separte values for active state, and also same value for hover state*/
  // &:active {
  //   background-color: var(--p-surface-selected-pressed);
  // }
}

.ListItem {
  position: relative;
  @include focus-ring($border-width: rem(-1px));

  // .ListItem + & {
  //   border-top: border('divider');
  // }

  &::after {
    border-radius: rem(2px);
  }

  /*These radius were not needed */

  // &:last-of-type {
  //   border-bottom-left-radius: var(--p-border-radius-wide);
  //   border-bottom-right-radius: var(--p-border-radius-wide);

  //   .ItemWrapper {
  //     border-bottom-left-radius: var(--p-border-radius-wide);
  //     border-bottom-right-radius: var(--p-border-radius-wide);
  //   }
  // }

  // stylelint-disable-next-line selector-max-class, selector-max-specificity
  &:last-of-type.focused::after {
    border-bottom-left-radius: var(--p-border-radius-wide);
    border-bottom-right-radius: var(--p-border-radius-wide);
  }

  // stylelint-disable-next-line selector-max-class
  &.focused {
    @include focus-ring($style: 'focused');
    z-index: resource-list-item(clickable-stacking-order);
  }

  // stylelint-disable-next-line selector-max-class, selector-max-specificity, selector-max-combinators
  * + ul > &:first-of-type.focused::after {
    top: rem(1px);
  }
  &::marker {
    content: '';
  }
}
